#include <stdio.h>
#include <stdlib.h>

int N = 5;

void litter_heap_malloc()
{
    int *trash = malloc(N * sizeof(int));
    printf("P (litter): %p\n", trash);
    for (int j; j < N; j++)
    {
        trash[j] = 0xF0F0F0F0;
    }
    free(trash);
}

void litter_heap_calloc()
{
    int *trash = calloc(N, sizeof(int));
    printf("P (litter): %p\n", trash);
    for (int j; j < N; j++)
    {
        trash[j] = 0xF0F0F0F0;
    }
    free(trash);
}

void test_malloc()
{
    int *m = malloc(N * sizeof(int));
    printf("P (malloc): %p\n", m);
    for (int j = 0; j < N; j++)
    {
        printf("V[%d]: %x\n", j, m[j]);
    }
    free(m);
}

void test_calloc()
{
    int *c = calloc(N, sizeof(int));
    printf("P (calloc): %p\n", c);
    for (int j = 0; j < N; j++)
    {
        printf("V[%d]: %x\n", j, c[j]);
    }
    free(c);
}

void *main()
{
    litter_heap_malloc();
    test_malloc();

    litter_heap_calloc();
    test_calloc();
}