#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct date
{
    unsigned int year;
    unsigned int month;
    unsigned int day;
} date_t;

typedef struct person
{
    char nickname[10];
    char surname[20];
    char name[20];
    date_t birthday;
} person_t;

person_t *
read_person(FILE *f)
{
    person_t *person = calloc(1, sizeof(*person));

    int read = fscanf(f, "%10s %20s %20s %u-%u-%u", person->nickname, person->surname, person->name, &(person->birthday.year), &(person->birthday.month), &(person->birthday.day));

    if (read != EOF)
    {
        return person;
    }
    else
    {
        return NULL;
    }
}

void print_person(person_t const *person)
{
    if (person == NULL)
    {
        printf("No person to print!");
        return;
    }
    date_t const *birthday = &(person->birthday);
    printf("%s \033[32m'%s'\033[0m %s\n", person->name, person->nickname, person->surname);
    printf("%u.%u.%u\n", birthday->day, birthday->month, birthday->year);
}

int main()
{
    // Static Person ("standing around on the stack")
    person_t *p = calloc(1, sizeof(*p));
    date_t d = {
        year : 1950,
        month : 10,
        day : 02,
    };
    strncpy(p->nickname, "Charlie", 7);
    strncpy(p->name, "Charles", 7);
    strncpy(p->surname, "Brown", 5);
    p->birthday = d;

    print_person(p);
    free(p);

    // Dynamic Person ("running on the heap")
    FILE *f = fopen("input.txt", "r");
    person_t *p2 = read_person(f);
    print_person(p2);
    free(p2);
    fclose(f);

    return 0;
}