#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "person.h"

person_t *read_person(FILE *f)
{
    person_t *p = calloc(1, sizeof(*p));

    int read = fscanf(f, "%10s %20s %20s %u-%u-%u",
                      p->nickname,
                      p->surname,
                      p->name,
                      &p->birthday.year,
                      &p->birthday.month,
                      &p->birthday.day);
    if (read != EOF)
    {
        return p;
    }
    else
    {
        free(p);
        return NULL;
    }
}

void print_person(person_t const *person)
{
    date_t const *birthday = &(person->birthday);
    printf("%s \033[32m'%s'\033[0m %s\n", person->name, person->nickname, person->surname);
    printf("%u.%u.%u\n", birthday->day, birthday->month, birthday->year);
}
