#include <math.h>

// find roots of ax^2 + bx + c
unsigned roots(double a, double b, double c, double *r)
{

  if (a != 0)
  {                                   // 1
    double p = b / a;                 // 2
    double q = c / a;                 // 3
    double d = (p / 2) * (p / 2) - q; // 4

    if (d > 0)
    {                          // 5
      r[0] = -p / 2 + sqrt(d); // 6
      r[1] = -p / 2 - sqrt(d); // 7
      return 2;                // 8
    }

    r[0] = -p / 2; // 9
    return 1;      // 10
  }

  if (b != 0)
  {                // 11
    r[0] = -b / c; // 12
    return 1;      // 13
  }

  return 0; // 14
}
