public class PolarVec2 implements Vec2 {
    private double r, phi;

    public PolarVec2(double x, double y) {
        this.setXandY(x, y);
    }

    void setXandY(double x, double y) {
        this.phi = Math.atan2(y, x);
        this.r = Math.sqrt(x * x + y * y);
    }

    public double getX() {
        return this.r * Math.cos(phi);
    }

    public double getY() {
        return this.r * Math.sin(phi);
    }

    public void setX(double v) {
        this.setXandY(v, this.getY());
    }

    public void setY(double v) {
        this.setXandY(this.getX(), v);
    }

    void translate(double x, double y) {
        this.setXandY(this.getX() + x, this.getY() + y);
    }

    public double length() {
        return r;
    }
}