package ast.expressions;

/**
 * This class represents a constant in an expression.
 */
public class ConstExpression extends Expression {

    private final int value;

    public ConstExpression(int value) {
        this.value = value;
    }

    public int getValue() {
        return value;
    }

    /**
     * Returns the abstract syntax of the constant
     */
    @Override
    public String toString() {
        return "Const_%d".formatted(this.getValue());
    }

    /**
     * Returns the value of the constant
     *
     * @return Value of the constant
     */
    @Override
    public int eval() {
        return this.getValue();
    }

}