package ast.expressions.binary;

import ast.expressions.Expression;
import ast.expressions.Operator;

public class AndExpression extends BinaryExpression {

    public AndExpression(Expression lhs, Expression rhs) {
        super(lhs, rhs, Operator.AND);
    }

    @Override
    public int eval() {
        // Convert operands from int to boolean
        boolean leftBool = this.getLhs().eval() != 0;
        boolean rightBool = this.getRhs().eval() != 0;

        return (leftBool && rightBool) ? 1 : 0;
    }
}
