package ast.expressions.binary;

import ast.expressions.Expression;
import ast.expressions.Operator;

public class OrExpression extends BinaryExpression {
    
     public OrExpression(Expression lhs, Expression rhs) {
        super(lhs, rhs, Operator.OR);
    }

    @Override
    public int eval() {
        // Convert operands from int to boolean
        boolean leftBool = this.getLhs().eval() != 0;
        boolean rightBool = this.getRhs().eval() != 0;

        return (leftBool || rightBool) ? 1 : 0;
    }
}
