package ast.expressions;

import org.junit.Test;

import ast.ASTFactory;

import org.junit.Before;

public class BasicTests {

    @Test
    public void testAddExpression() {
        Utils.testAST(ASTFactory.createAddExpression(ASTFactory.createConstExpression(42), ASTFactory.createConstExpression(271)), "Binary_+[Const_42, Const_271]",
                313);
    }

    @Test
    public void testConstExpression() {
        Utils.testAST(ASTFactory.createConstExpression(42), "Const_42", 42);
    }

    @Test
    public void testDivExpression() {
        Utils.testAST(ASTFactory.createDivExpression(ASTFactory.createConstExpression(3), ASTFactory.createConstExpression(2)), "Binary_/[Const_3, Const_2]", 1);
    }

    
    @Test
    public void testMulExpression() {
        Utils.testAST(ASTFactory.createMulExpression(ASTFactory.createConstExpression(42), ASTFactory.createConstExpression(2)), "Binary_*[Const_42, Const_2]", 84);
    }
    
    @Test
    public void testNegExpression() {
        Utils.testAST(ASTFactory.createNegExpression(ASTFactory.createConstExpression(42)), "Unary_~[Const_42]", -42);
    }
    
    
    
    @Test
    public void testSubExpression() {
        Utils.testAST(ASTFactory.createSubExpression(ASTFactory.createConstExpression(42), ASTFactory.createConstExpression(271)), "Binary_-[Const_42, Const_271]",
        -229);
    }
    
    @Test
    public void testSimpleFullTree() {
        Utils.testAST(ASTFactory.createNegExpression(ASTFactory.createMulExpression(ASTFactory.createDivExpression(ASTFactory.createNegExpression(ASTFactory.createAddExpression(ASTFactory.createConstExpression(31),
                ASTFactory.createSubExpression(ASTFactory.createConstExpression(1337), ASTFactory.createConstExpression(99)))), ASTFactory.createConstExpression(42)), 
                ASTFactory.createSubExpression(ASTFactory.createConstExpression(187), ASTFactory.createDivExpression(ASTFactory.createConstExpression(54), ASTFactory.createNegExpression(ASTFactory.createConstExpression(8)))))),
        "Unary_~[Binary_*[Binary_/[Unary_~[Binary_+[Const_31, Binary_-[Const_1337, Const_99]]], Const_42], Binary_-[Const_187, Binary_/[Const_54, Unary_~[Const_8]]]]]",
        5790);
    }

}