package ast.expressions.unary;

import ast.expressions.Expression;
import ast.expressions.Operator;

/**
 * This abstract class represents a unary expression
 */
public abstract class UnaryExpression extends Expression {

    private final Expression operand;
    private final Operator operator;

    UnaryExpression(Expression operand, Operator operator) {
        this.operand = operand;
        this.operator = operator;
    }

    public Expression getOperand() {
        return operand;
    }

    public Operator getOperator() {
        return operator;
    }

    /**
     * This method should return the abstract syntax of the full expression
     * to the console.
     * Note, that the method can be used by all subclasses.
     */
    @Override
    public String toString() {
        // TODO
        return null;
    }

}
