package main;

import java.util.List;

import ast.expressions.Expression;
import lexer.Lexer;
import lexer.Token;
import parser.Parser;

public class Main {
    
    public static void main(String[] args) {
		if (args.length != 1) {
            System.out.println("You have to provide one expression");
            System.exit(-1);
        }

        Lexer lexer = new Lexer();
        List<Token> lexedExpression = null;
        try {
            lexedExpression = lexer.lex(args[0]);
        } catch (Exception e) {
            System.out.println("Error occurred while lexing:");
            e.printStackTrace();
            return;
        }
        Parser parser = new Parser();
        Expression expression = null;
        
        try {
            expression = parser.parse(lexedExpression);
        } catch (Exception e) {
            System.out.println("Error occurred while parsing:");
            e.printStackTrace();
            return;
        }

        System.out.println("Abstract Syntax of the Expression:");
        expression.print();
        System.out.println("Evaluating the expression gives: " + expression.eval());
    }
}
