package lexer;

import static org.junit.Assert.assertThrows;
import static org.junit.Assert.assertTrue;

import java.util.List;

import org.junit.Test;

public class SimpleTests {
    
    @Test
    public void simpleLexerTest() throws Exception {
        String s = "int a = 5 + 3";
        Lexer lexer = new Lexer();
        List<Token> result = null;
        result = lexer.lex(s);

        System.out.println(result.toString());
        
    }

    @Test
    public void invalidDoubleOperator() {
        String s = "int a = 5 & 2";
        Lexer lexer = new Lexer();
        assertThrows(Exception.class, () -> {
            lexer.lex(s);
        });
    }

    @Test
    public void validDoubleOperator() throws Exception {
        String s = "int a = 5 && 2";
        Lexer lexer = new Lexer();
        List<Token> result = null;
        result = lexer.lex(s);
        assertTrue(result.stream().anyMatch((token) -> token.getValue() == "&&"));
    }
}
