package lexer;

public class Token {
    public enum Category {
        Identifier, Operator, Const, Keyword, ASSIGN, LPAREN,
        RPAREN, LBRACE, RBRACE
    }

    private final Category category;
    private final String value;
    private final int line;

    public Token(Category category, String value, int line) {
        this.category = category;
        this.value = value;
        this.line = line;
    }

    @Override
    public String toString() {
        assert (category != null);
        if (value != null) {
            return "(%s,%s,%d)".formatted(category, value, line);
        }
        return "(%s,%d)".formatted(category, line);
    }

    public Category getCategory() {
        return category;
    }

    public String getValue() {
        return value;
    }

    public int getLine() {
        return line;
    }

    
}