package ast.expressions;

import org.junit.Before;
import org.junit.Test;

import ast.ASTFactory;

public class BonusTests {
    
    @Test
    public void testEqualsExpression() {
        Utils.testAST(ASTFactory.createEqualsExpression(ASTFactory.createConstExpression(3), ASTFactory.createConstExpression(2)), "Binary_==[Const_3, Const_2]", 0);
        Utils.testAST(ASTFactory.createEqualsExpression(ASTFactory.createConstExpression(1), ASTFactory.createConstExpression(1)), "Binary_==[Const_1, Const_1]", 1);
    }
    
    @Test
    public void testNotExpression() {
        Utils.testAST(ASTFactory.createNotExpression(ASTFactory.createConstExpression(0)), "Unary_![Const_0]", 1);
    }

    @Test
    public void testOrExpression() {
        Utils.testAST(ASTFactory.createOrExpression(ASTFactory.createConstExpression(42), ASTFactory.createConstExpression(0)), "Binary_||[Const_42, Const_0]", 1);
    }
    
    @Test
    public void testAndExpression() {
        Utils.testAST(ASTFactory.createAndExpression(ASTFactory.createConstExpression(1), ASTFactory.createConstExpression(2)), "Binary_&&[Const_1, Const_2]", 1);
    }

    @Test
    public void testXorExpression() {
        Utils.testAST(ASTFactory.createXorExpression(ASTFactory.createConstExpression(42), ASTFactory.createConstExpression(0)), "Binary_^[Const_42, Const_0]", 1);
        Utils.testAST(ASTFactory.createXorExpression(ASTFactory.createConstExpression(0), ASTFactory.createConstExpression(0)), "Binary_^[Const_0, Const_0]", 0);
        Utils.testAST(ASTFactory.createXorExpression(ASTFactory.createConstExpression(0), ASTFactory.createConstExpression(42)), "Binary_^[Const_0, Const_42]", 1);
        Utils.testAST(ASTFactory.createXorExpression(ASTFactory.createConstExpression(42), ASTFactory.createConstExpression(42)), "Binary_^[Const_42, Const_42]", 0);
    }

    @Test
    public void testFullTree() {
        Utils.testAST(ASTFactory.createDivExpression(ASTFactory.createMulExpression(ASTFactory.createConstExpression(3), ASTFactory.createSubExpression(
                ASTFactory.createAddExpression(ASTFactory.createNegExpression(ASTFactory.createConstExpression(42)), ASTFactory.createConstExpression(3)),
                ASTFactory.createConstExpression(5))), ASTFactory.createAddExpression(ASTFactory.createConstExpression(2),
                        ASTFactory.createAndExpression(
                                ASTFactory.createOrExpression(ASTFactory.createConstExpression(1), ASTFactory.createXorExpression(
                                        ASTFactory.createAndExpression(ASTFactory.createNotExpression(ASTFactory.createConstExpression(0)),
                                                ASTFactory.createConstExpression(0)),
                                        ASTFactory.createConstExpression(1))),
                                ASTFactory.createEqualsExpression(ASTFactory.createConstExpression(8), ASTFactory.createConstExpression(1))))),
                "Binary_/[Binary_*[Const_3, Binary_-[Binary_+[Unary_~[Const_42], Const_3], Const_5]], Binary_+[Const_2, Binary_&&[Binary_||[Const_1, Binary_^[Binary_&&[Unary_![Const_0], Const_0], Const_1]], Binary_==[Const_8, Const_1]]]]",
                -66);
    }
}
